#ifndef LNMETAM_H
#define LNMETAM_H

/*
e  Tlnmeta
*/

#define LNMETA_MODE_TEXT	(0)
#define LNMETA_MODE_HEX		(1)
#define LNMETA_MODE_UNWRAP	(0)
#define LNMETA_MODE_WRAP	(1)
#define LNMETA_MODE_WORDWRAP	(2)

// **********************************************************************
// Tlnmeta
class   Tlnmeta_mode_hex;
typedef Tlnmeta_mode_hex *Tlnmeta_mode_hex_p;

class   Tlnmeta_mode_text;
typedef Tlnmeta_mode_text *Tlnmeta_mode_text_p;

// text
class   Tlnmeta_mode_unwrap;
typedef Tlnmeta_mode_unwrap *Tlnmeta_mode_unwrap_p;

class   Tlnmeta_mode_wrap;
typedef Tlnmeta_mode_wrap *Tlnmeta_mode_wrap_p;

// **********************************************************************
//e  Tlnmeta
// **********************************************************************
class   Tlnmeta_mode_hex:
	public Tlnmeta_mode_lnstream_call<Tlnstream_hex>
{
public:
	inline Tlnmeta_mode_hex(Tstream& user_stream):
	Tlnmeta_mode_lnstream_call<Tlnstream_hex>(user_stream){}

// 
	//   ,   . 
	//  
	SELF_Toos

//  o
public:
	//  
	char_p	mode_description(){return "hex";}
};

// **********************************************************************
// text
class   Tlnmeta_mode_unwrap:
	public Tlnmeta_mode_lnstream_call<Tlnstream_unwrap>
{
public:
	inline Tlnmeta_mode_unwrap(Tstream& user_stream):
	Tlnmeta_mode_lnstream_call<Tlnstream_unwrap>(user_stream){}

// 
public:
	// /  
	//   . 
	CALL_Toos
	 {
	  t_err		res;
	  if(
	     ( (res=(oper==OBJ_LOAD)?
		     Tlnstream_text_state::obj_load(f):
		     Tlnstream_text_state::obj_save(f))!=ERR_NO )
	     ||( (res=(oper==OBJ_LOAD)?
		     Tlnstream_unwrap_state::obj_load(f):
		     Tlnstream_unwrap_state::obj_save(f))!=ERR_NO )
	    )return res;

	  return Tlnmeta_mode_lnstream_call<Tlnstream_unwrap>::oos(oper,f);
	 }
	//   ,   . 
	//  
	SELF_Toos

//  o
public:
	//  
	char_p	mode_description(){return "unwrap";}
};

// **********************************************************************
class   Tlnmeta_mode_wrap:
	public Tlnmeta_mode_lnstream_call<Tlnstream_wrap>
{
public:
	inline Tlnmeta_mode_wrap(Tstream& user_stream):
	Tlnmeta_mode_lnstream_call<Tlnstream_wrap>(user_stream){}

// 
public:
	// /  
	//   . 
	CALL_Toos
	 {
	  t_err		res;
	  if(
	     ( (res=(oper==OBJ_LOAD)?
		     Tlnstream_text_state::obj_load(f):
		     Tlnstream_text_state::obj_save(f))!=ERR_NO )
	     ||( (res=(oper==OBJ_LOAD)?
		     Tlnstream_unwrap_state::obj_load(f):
		     Tlnstream_unwrap_state::obj_save(f))!=ERR_NO )
	    )return res;

	  return Tlnmeta_mode_lnstream_call<Tlnstream_wrap>::oos(oper,f);
	 }

	//   ,   . 
	//  
	SELF_Toos

//  o
public:
	//  
	char_p	mode_description(){return "wrap";}

	//   
	//t_err	mode_prepare();

};

// **********************************************************************
class   Tlnmeta_mode_wordwrap:
	public Tlnmeta_mode_lnstream_call<Tlnstream_wordwrap>
{
public:
	inline Tlnmeta_mode_wordwrap(Tstream& user_stream):
	Tlnmeta_mode_lnstream_call<Tlnstream_wordwrap>(user_stream){}

// 
public:
	// /  
	//   . 
	CALL_Toos
	 {
	  t_err		res;
	  if(
	     ( (res=(oper==OBJ_LOAD)?
		     Tlnstream_text_state::obj_load(f):
		     Tlnstream_text_state::obj_save(f))!=ERR_NO )
	     ||( (res=(oper==OBJ_LOAD)?
		     Tlnstream_unwrap_state::obj_load(f):
		     Tlnstream_unwrap_state::obj_save(f))!=ERR_NO )
	    )return res;

	  return Tlnmeta_mode_lnstream_call<Tlnstream_wordwrap>::oos(oper,f);
	 }

	//   ,   . 
	//  
	SELF_Toos

//  o
public:
	//  
	char_p	mode_description(){return "word wrap";}

	//   
	//t_err	mode_prepare();
};

// **********************************************************************
class   Tlnmeta_mode_text:public Tlnmeta_mode_lnstream_sel
{
public:
	inline Tlnmeta_mode_text(Tstream& user_stream):
		Tlnmeta_mode_lnstream_sel(user_stream)
	 {
	  Tlnmeta_mode_p	p[3];

	  p[0]=new Tlnmeta_mode_unwrap(user_stream);
	  p[1]=new Tlnmeta_mode_wrap(user_stream);
	  p[2]=new Tlnmeta_mode_wordwrap(user_stream);
	  if((!p[0])||(!p[1])||(!p[2])){err(ERR_NOMEM);return;}

	  submodes[0];
	  submodes+=Tlist_item_p(p[0]);
	  submodes++;
	  submodes+=Tlist_item_p(p[1]);
	  submodes++;
	  submodes+=Tlist_item_p(p[2]);

	  set_submode_number(0);
	 }

// 
	//   ,   . 
	//  
	SELF_Toos

//  o
public:
	//  
	char_p	mode_description(){return "text";}
};

// **********************************************************************
#endif

