#ifndef KEYB_H
#define KEYB_H

/*
           getch()
*/
// **********************************************************************
// **********************************************************************
//
class 	Tkeyb;
typedef	Tkeyb *Tkeyb_p;

//
class	Tkeyb_key;
typedef Tkeyb_key *Tkeyb_key_p;

// : ext|ascii:code
class	Tkeyb_actions;
typedef Tkeyb_actions *Tkeyb_actions_p;

//    
class 	Tkeyb_action;
typedef Tkeyb_action *Tkeyb_action_p;

//  obj_p    this
typedef void (*t_keyb_action_f)( Tkeyb_key key, void_p obj_p );
//    
#define KEYB_ACTION(name) void name##( Tkeyb_key key, void_p obj_p )

// **********************************************************************
//
class	Tkeyb_key
{
public:
	inline Tkeyb_key(char n_ext=0,char n_ascii=0)
	 {ext=n_ext;ascii=n_ascii;}

	//  
	char ext;
	//
	char ascii;
};
#define KEYB_DEF_KEY	Tkeyb_key
//     
#define KEY_EXT		1
#define KEY_ASCII 	0

// **********************************************************************
//    
class Tkeyb_action
{
public:
	inline Tkeyb_action( t_keyb_action_f new_action_f=NULL, void_p new_obj_p=NULL )
	 {
	  action_f=new_action_f;
	  obj_p=new_obj_p;
	 }

	t_keyb_action_f	action_f;
	void_p		obj_p;
};

#define KEYB_DEF_ACTION_F	NULL
#define KEYB_DEF_OBJ_P		NULL
#define	KEYB_DEF_ACTION		Tkeyb_action()

// **********************************************************************
// : ext:ascii
class	Tkeyb_actions
{
public:
	//  
	Tkeyb_actions();

	//  
	virtual void clear(Tkeyb_action& keyb_action=KEYB_DEF_ACTION);

	// 
	Tkeyb_action actions[2][256];
};

// **********************************************************************
//    
#define KEYB_ACTION_NOWAIT	0
#define KEYB_ACTION_WAIT	1

//
class	Tkeyb
{
public:
	//    
	Tkeyb( Tkeyb_actions_p actions_p=NULL);
	virtual ~Tkeyb();

//      
public:
	//    /
	//return ERR_NFOUND if !pressed&&NOWAIT else exec
	virtual t_err action( int wait=KEYB_ACTION_WAIT );

	//   ext|ascii
        //return ERR_ZDATA if not installed
	virtual t_err exec( Tkeyb_key key );

	//    
	virtual	Tkeyb_key get_last_key();

//     
public:
	//   ext|ascii
	virtual t_err install( Tkeyb_key key, Tkeyb_action& new_action=KEYB_DEF_ACTION );
	// 
	inline	t_err install( Tkeyb_key key, t_keyb_action_f new_action_f, void_p obj_p=NULL )
	 {return install( key,Tkeyb_action(new_action_f,obj_p) );}

	//     */
	virtual Tkeyb_action get_installed( Tkeyb_key key );

	//   ext|ascii
	virtual Tkeyb_action replace( Tkeyb_key key, Tkeyb_action& new_action=KEYB_DEF_ACTION );
	// 
	inline	Tkeyb_action replace( Tkeyb_key key, t_keyb_action_f new_action_f, void_p obj_p=NULL )
	 {return replace( key,Tkeyb_action(new_action_f,obj_p) );}

	//  
	virtual	Tkeyb_actions_p get_keyb_actions();

protected:
	//  ext:char
	Tkeyb_actions_p keyb_actions_p;

private:
	//          
	char	need_free_mem;
	//  
	Tkeyb_key 	last_key;
};

// **********************************************************************
#endif
