#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "tstream\tstream.h"
#include "linestrm\linestrm.h"
#include "linestrm\lnstrmh.h"

// **********************************************************************
//  ( + ):  hex ascii
//adr
#define PART_ADR	(9)
#define SP_ADR		(2)
//hex 
#define PART_HEX_CH	(2)
#define SP_HEX_CH	(1)
//hex 
#define PART_HEX_GR	((PART_HEX_CH+SP_HEX_CH)*4)
#define SP_HEX_GR	(1)
//hex 
#define PART_HEX	((PART_HEX_GR+SP_HEX_GR)*4)
#define SP_HEX		(1)
//ascii
#define PART_ASCII	(16)
#define SP_ASCII	(0)
//   
#define SIZE_ADR	(PART_ADR+SP_ADR)
#define SIZE_HEX	(PART_HEX+SP_HEX)
#define SIZE_ASCII	(PART_ASCII+SP_ASCII)
#define SIZE_LINE	(SIZE_ADR+SIZE_HEX+SIZE_ASCII)
// 
#define START_ADR	(0)
#define START_HEX	(SIZE_ADR)
#define START_ASCII	(START_HEX+SIZE_HEX)

// **********************************************************************
//  
	Tlnstream_hex::Tlnstream_hex()
{
	//  
	lines=0;
	last_line=0;

	//    
	stream_line_size=0;
}

// **********************************************************************
// 
// **********************************************************************
//  , / . . 
t_err	Tlnstream_hex::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if( (res=Tline_stream::obj_load(fi))!=ERR_NO )
	 return res;

	fread(&lines,1,sizeof(lines),fi);
	fread(&last_line,1,sizeof(last_line),fi);

	return ERR_NO;
}
// **********************************************************************
//  , / . . 
t_err	Tlnstream_hex::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	  //warn("Tlnstream_hex::obj_save::obj_save CALLED");

	if( (res=Tline_stream::obj_save(fo))!=ERR_NO )
	 return res;

	fwrite(&lines,1,sizeof(lines),fo);
	fwrite(&last_line,1,sizeof(last_line),fo);

	  //warn("Tlnstream_hex::obj_save::obj_save OK");

	return ERR_NO;
}

// **********************************************************************
//  
// **********************************************************************
//    ( tty \?)  
//return NULL on error or feof()
//Tstring_p need external delete
Tstring_p Tlnstream_hex::read()
{
Tstring_p	p;
char		s[80];

	//EOF found during read
	if(next_line()!=ERR_NO)
	set_pos(0,SEEK_END);

	//no more lines
	if(!stream_line_size)return NULL;

	p=new Tstring(0,SIZE_LINE);
	if(!p){err(ERR_NOMEM);return NULL;}

	// 
	memset(-*p,' ',SIZE_LINE);
	*(-*p+SIZE_LINE)=0;

	// 
	set_pos(get_pos()-stream_line_size);
	sprintf(s,"%08X|",get_pos());
	memcpy(-*p,s,PART_ADR);

	//hex & ascii 
	read_block(s,stream_line_size);
	{
	char_p		h,a,t;
	u_int 		h_gr=0,i;

	h=-*p+START_HEX;
	a=-*p+START_ASCII;
	t=s;

	for(i=0;i<stream_line_size;i++)
	 {
	  char		s[32];

	  //hex 
	  sprintf(s,"%02X",u_int(u_char(*t)));
	  //*u_int_p(h)=*u_int_p(s);
	  //h+=3;
	  *h++=s[0];
	  *h++=s[1];

	  //hex  
	  if(++h_gr>=4)
	   {
	    h_gr=0;
	    h+=2;
	   }
	  else *h++='-';

	  //ascii 
	  *a++=(u_char(*t)<32)?char(0x2e):*t;

	  //  
	  t++;
	 }
	}

	return p;
}

// **********************************************************************
//   line,  ! ERR_BOUND
t_err	Tlnstream_hex::seek(u_int line)
{
	if(line>=get_lines())return ERR_BOUND;
	set_pos(line*16);
	last_line=line;
	return ERR_NO;
}

// **********************************************************************
//       
u_int	Tlnstream_hex::get_lines()
{
	//?   -    -   fsize()
	if(!lines)
	 {
	  u_int		fs;

	  fs=fsize();
	  lines=(fs%16)?fs/16+1:fs/16;
	 }
	return lines;
}

// **********************************************************************
//  seek
u_int	Tlnstream_hex::get_percent()
{
double		d;

	d=100.0;
	d/=fsize();
	d*=last_line*16;

	return (u_int)d;
}

// **********************************************************************
//     -1 on error
u_int	Tlnstream_hex::get_line()
{
u_int		pos;

	pos=get_pos();
	if(eof())return get_lines();
	return pos/16;
}

// **********************************************************************
//    
// **********************************************************************
//     ,  ! ERR_BOUND
//      
t_err	Tlnstream_hex::next_line()
{
u_int		pos;
u_int		fs;

	stream_line_size=0;
	fs=fsize();
	pos=get_pos();

	if(
	   (eof())
	   ||(pos==fs)
	  )return ERR_BOUND;

	if(fs<pos+16)
	 {
	  stream_line_size=fs-pos;
	 }
	else
	 {
	  stream_line_size=16;
	 }

	set_pos(pos+stream_line_size);
	return ERR_NO;
}

// **********************************************************************

