#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "tstream\tstream.h"
#include "linestrm\linestrm.h"
#include "linestrm\lnstrmt.h"
#include "linestrm\lnstrmtu.h"

// **********************************************************************
// a 
// 
// **********************************************************************
//  , / . . 
t_err	Tlnstream_unwrap_state::obj_load(FILE *fi)
{
	if(!fi)return err(ERR_ZPAR);

	fread(&is_lines_counted,1,sizeof(is_lines_counted),fi);
	fread(&lines,1,sizeof(lines),fi);
	fread(&last_line,1,sizeof(last_line),fi);
	fread(&last_line_pos,1,sizeof(last_line_pos),fi);

	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err	Tlnstream_unwrap_state::obj_save(FILE *fo)
{
	if(!fo)return err(ERR_ZPAR);

	fwrite(&is_lines_counted,1,sizeof(is_lines_counted),fo);
	fwrite(&lines,1,sizeof(lines),fo);
	fwrite(&last_line,1,sizeof(last_line),fo);
	fwrite(&last_line_pos,1,sizeof(last_line_pos),fo);

	return ERR_NO;
}

// **********************************************************************
// 
// 
// **********************************************************************
//  , / . . 
t_err	Tlnstream_unwrap::obj_load(FILE *fi)
{
t_err		res;
	if(!fi)return err(ERR_ZPAR);

	if( (res=Tlnstream_text::obj_load(fi))!=ERR_NO )
	 return res;

	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err	Tlnstream_unwrap::obj_save(FILE *fo)
{
t_err		res;
	if(!fo)return err(ERR_ZPAR);

	if( (res=Tlnstream_text::obj_save(fo))!=ERR_NO )
	 return res;

	return ERR_NO;
}

// **********************************************************************
//  
// **********************************************************************
//  
t_err	Tlnstream_unwrap::seek(u_int nline)
{
u_int		old_line=last_line;
u_int		old_pos=last_line_pos;
/*
	{
	 char s[80];
	 sprintf(s,"Tlnstream_unwrap::seek\nline %u",nline);
	 warn(s);
	}
*/
	//?   
	if(last_line>nline)
	 {
	  set_pos(0);
	  last_line=0;
	  last_line_pos=0;
	 }
	set_pos(last_line_pos);

	//  
	while(1)
	 {
	  if(last_line==nline)break;

	  if(next_line()!=ERR_NO)
	   {
	    last_line=old_line;
	    last_line_pos=old_pos;
	    set_pos(last_line_pos);
	    return ERR_BOUND;
	   }
	  last_line++;
	 }
	last_line_pos=get_pos();

	return ERR_NO;
}

// **********************************************************************
//       
u_int	Tlnstream_unwrap::get_lines()
{
	if(!is_lines_counted)
	 {
	  u_int		last_pos;

	  last_pos=get_pos();
	  set_pos(0);
	  lines=0;

	  while(1)
	   {
	    // EOF
	    if(next_line()!=ERR_NO)
	     {
	      //?  !
	      if(converted_line_size)lines++;

	      is_lines_counted=1;
	      break;
	     }
	    lines++;
	   }
	  set_pos(last_pos);
	 }
/*
	{
	 char		s[80];

	 sprintf(s,"unwrap lines %u\nwrap lines %u",lines[0],lines[1]);
	 warn(s);
	}
*/
	return lines;
}

// **********************************************************************
//  seek
u_int	Tlnstream_unwrap::get_percent()
{
double		d;

	d=100.0;
	d/=fsize();
	d*=last_line_pos;

	return (u_int)d;
}

// **********************************************************************
//     -1 on error
u_int	Tlnstream_unwrap::get_line()
{
u_int		line;
u_int		pos;

	pos=get_pos();
	set_pos(0);
	line=0;

	while(1)
	 {
	  //? EOF
	  if(next_line()!=ERR_NO)return get_lines();
	  if(pos<=get_pos())return line;
	  line++;
	 }
}

// **********************************************************************
//    
// **********************************************************************
//   ,  ! ERR_BOUND
//      
t_err	Tlnstream_unwrap::next_line()
{
int		ch;

	//    
	converted_line_size=0;
	displayed_line_size=0;
	stream_line_size=0;

	while(1)
	 {
	  ch=read_ch();

	  //   <EOF>
	  if(eof())return ERR_BOUND;

	  converted_line_size++;
	  stream_line_size++;
	  //format tty for display & load
	  switch(ch)
	   {
	    //   \n
	    case '\n':
	       return ERR_NO;
	    //skip \r
	    case '\r':
	       break;
	    //expand \t
	    case '\t':
	     {
	      u_int	dx=displayed_line_size%8;

	      //displayed_line_size+=8;
	      displayed_line_size+=(!dx)?8:dx;

	      converted_line_size+=7;
	     }break;

	    default: displayed_line_size++;
	   }
	 }
}

// **********************************************************************

