#include <stdio.h>
#include <stdlib.h>

#include <mydef.h>
#include <tstring.h>

#include "plist\plist.h"

// ***********************************************************************
//    
// ***********************************************************************
//  
	Tplist_item::Tplist_item()
{
	next=prev=NULL;
	pointer=NULL;
}

// ***********************************************************************
	Tplist_item::~Tplist_item()
{
}

// ***********************************************************************
//     
// ***********************************************************************
	Tplist_iterator::Tplist_iterator(Tplist& aplist):plist(aplist)
{
Tplist_item_p		p,t;

	no_longer_valid=no_longer_exist=0;
	index=0;
	item=plist.list;

	//add to plist iterators list
	p=new Tplist_item;
	if(!p){err(ERR_NOMEM);return;}
	p->pointer=this;

	t=plist.iterators;
	if(!t)plist.iterators=p;
	else while(1)
	 {
	  if(!t->next)
	   {
	    t->next=p;
	    break;
	   }
	  t=t->next;
	 }
}

// ***********************************************************************
	Tplist_iterator::~Tplist_iterator()
{
Tplist_item_p		p,t;

	//  
	if(no_longer_exist)return;

	//remove from plist iterators list
	p=NULL;
	t=plist.iterators;
	while(1)
	 {
	  if(!t)break;
	  if(t->pointer==this)
	   {
	    if(!p)plist.iterators=t->next;
	    else p->next=t->next;

	    delete t;
	    break;
	   }
	  p=t;
	  t=t->next;
	 }
}
// ***********************************************************************
// ***********************************************************************
//    
void	Tplist_iterator::operator+=(Tlist_item_p pointer)
{
Tplist_item_p		p;

	if(no_longer_exist){err2(ERR_DENIED,"   ");return;}
	if(no_longer_valid){err2(ERR_DENIED,"   ");return;}

	//  
	p=new Tplist_item;
	if(!p){ err(ERR_NOMEM); return; }

	//?
	if(!plist.items++)
	 {
	  plist.last=plist.list=item=p;
	  index=0;
	 }
	else
	 {
	  if(!item){ err2(ERR_INTERNAL,"list error"); return; }
	  p->next=item->next;
	  item->next=p;
	  p->prev=item;
	  item=p;

	  if(p->next)p->next->prev=p;
	  else plist.last=p;
	 }

	p->pointer=pointer;

	//    
	send_new_list();
}

// ***********************************************************************
//    
void	Tplist_iterator::operator-=(Tlist_item_p pointer)
{
Tplist_item_p		p;

	if(no_longer_exist){err2(ERR_DENIED,"   ");return;}
	if(no_longer_valid){err2(ERR_DENIED,"   ");return;}

	//  
	p=new Tplist_item;
	if(!p){ err(ERR_NOMEM); return; }

	//?
	if(!plist.items++)
	 {
	  plist.last=plist.list=item=p;
	  index=-1;
	 }
	else
	 {
	  if(!item){ err2(ERR_INTERNAL,"list error"); return; }

	  if(item->prev)
	   {
	    item->prev->next=p;
	    p->prev=item->prev;
	   }
	  else plist.list=p;

	  p->next=item;
	  item->prev=p;
	  item=p;
	 }

	p->pointer=pointer;

	// 
	index++;

	//    
	send_new_list();
}

// ***********************************************************************
//  
t_err	Tplist_iterator::operator~()
{
Tplist_item_p		p,n;

	if(no_longer_exist)return err2(ERR_DENIED,"   ");
	if(no_longer_valid)return err2(ERR_DENIED,"   ");

	if(!plist.items)return ERR_NFOUND;
	if(!item)return err2(ERR_INTERNAL,"list error");

	//?
	if(!--plist.items)
	 {
	  if(plist.list)delete plist.list;
	  plist.list=plist.last=item=NULL;
	  index=0;

	  //    
	  send_new_list();
	  return ERR_NO;
	 }

	p=item->prev;
	n=item->next;
	delete item;
	item=NULL;

	if(n){ n->prev=p; item=n; }
	else plist.last=p;

	if(p){ p->next=n; item=p; index--; }
	else plist.list=n;

	if(!item)return err2(ERR_INTERNAL,"list error");

	//    
	send_new_list();
	return ERR_NO;
}

// ***********************************************************************
//  
t_err	Tplist_iterator::operator++(int)
{
	if(no_longer_exist)return err2(ERR_DENIED,"   ");
	if(no_longer_valid)return err2(ERR_DENIED,"   ");

	if(!plist.items)return ERR_NFOUND;
	if(index>=plist.items)return err2(ERR_INTERNAL,"list error");

	if(!item->next)return ERR_BOUND;

	item=item->next;
	index++;
	return ERR_NO;
}

// ***********************************************************************
t_err	Tplist_iterator::operator--(int)
{
	if(no_longer_exist)return err2(ERR_DENIED,"   ");
	if(no_longer_valid)return err2(ERR_DENIED,"   ");

	if(!plist.items)return ERR_NFOUND;
	if(index>=plist.items)return err2(ERR_INTERNAL,"list error");

	if(!item->prev)return ERR_BOUND;

	item=item->prev;
	index--;
	return ERR_NO;
}

// ***********************************************************************
// 
Tlist_item_p	 Tplist_iterator::operator-()
{
	if(no_longer_exist){err2(ERR_DENIED,"   ");return NULL;}
	if(no_longer_valid){err2(ERR_DENIED,"   ");return NULL;}

	if(!plist.items)return NULL;
	if( (!item)||(index>=plist.items) )
	 {err2(ERR_INTERNAL,"list error");return NULL;}
	return item->pointer;
}

// ***********************************************************************
//    if NULL can happened error
Tlist_item_p	 Tplist_iterator::operator[](u_int new_index)
{
	if(no_longer_exist){err2(ERR_DENIED,"   ");return NULL;}

	if(no_longer_valid)
	 {
	  if(new_index){err2(ERR_DENIED,"   ");return NULL;}
	  no_longer_valid=0;

	  item=plist.list;
	  index=0;
	 }

	if((!plist.items)||(new_index>=plist.items))return NULL;
	if(index>=plist.items){err2(ERR_INTERNAL,"list error");return NULL;}

	//set next
	item=plist.list;
	if(!item){err2(ERR_INTERNAL,"list error");return NULL;}

	for( index=0; index<new_index; index++ )
	 {
	  //set next
	  item=item->next;
	  if(!item){err2(ERR_INTERNAL,"list error");return NULL;}
	 }

	return item->pointer;
}

// ***********************************************************************
//     
void	Tplist_iterator::send_new_list()
{
Tplist_item_p		t;

	if(no_longer_exist){err2(ERR_DENIED,"   ");}
	if(no_longer_valid){err2(ERR_DENIED,"   ");}

	t=plist.iterators;
	while(1)
	 {
	  if(!t)break;
	  if(t->pointer)
	   {
	    if(t->pointer!=this)
	     (Tplist_iterator_p(t->pointer))->no_longer_valid=1;
	   }
	  else {err2(ERR_INTERNAL,"iterators list error");break;}
	  t=t->next;
	 }
}

// ***********************************************************************
//   
// ***********************************************************************
//  
	Tplist::Tplist()
{
	access_p=NULL;
	iterators=NULL;

	init_defaults();

	//   
	access_p=new Tplist_iterator(*this);
	if(!access_p){err(ERR_NOMEM);return;}
}

// ***********************************************************************
//   
void	Tplist::init_defaults()
{
	items=0;
	last=list=NULL;

	//       
	if(access_p)(*access_p)[0];
}

// ***********************************************************************
	Tplist::~Tplist()
{
	// 
	zap(1);

	//   
	delete access_p;
	access_p=NULL;

	//  ,    
Tplist_item_p		t;

	t=iterators;
	while(1)
	 {
	  if(!t)break;
	  if(t->pointer)
	   (Tplist_iterator_p(t->pointer))->no_longer_exist=
	    (Tplist_iterator_p(t->pointer))->no_longer_valid=1;
	  t=t->next;
	 }
}

// ***********************************************************************
// 
void	Tplist::zap(char destruct_only)
{
Tplist_item_p	p[2];
u_Int		i;

	// 
	p[0]=list;
	for(i=0; i<items; i++)
	 {
	  if(!p[0])break;
	  p[1]=p[0];
	  p[0]=p[0]->next;
	  delete p[1];
	 }
	//,   
	if(destruct_only)return;

	//  ,    
Tplist_item_p		t;

	t=iterators;
	while(1)
	 {
	  if(!t)break;
	  if(t->pointer)
	   (Tplist_iterator_p(t->pointer))->no_longer_valid=1;
	  else {err2(ERR_INTERNAL,"iterators list error");break;}
	  t=t->next;
	 }

	//     
	init_defaults();
}

// ***********************************************************************

