#ifndef PLIST_H
#define PLIST_H

/*
	WIN32 version
*/

// ***********************************************************************
// ***********************************************************************
// 
class	Tlist_item{};
typedef Tlist_item *Tlist_item_p;

//   
class	Tplist_access;

//    
class	Tplist_item;
typedef Tplist_item *Tplist_item_p;
//  
class	Tplist_iterator;
typedef Tplist_iterator *Tplist_iterator_p;
//o   
class	Tplist;
typedef Tplist *Tplist_p;

// ***********************************************************************
// ***********************************************************************
//    
class	Tplist_item
{
public:
	// 
	Tlist_item_p   	pointer;

	//
	Tplist_item_p	next;
	Tplist_item_p	prev;

	//  
	Tplist_item();
	~Tplist_item();
};

// ***********************************************************************
// ***********************************************************************
//   
class	Tplist_access
{
public:
	//    
	virtual	void operator+=(Tlist_item_p pointer)=0;
	//    
	virtual	void operator-=(Tlist_item_p pointer)=0;

	//   ERR_NFOUND if can't
	//   +1,  !exist  -1  
	virtual	t_err operator~()=0;

	//     ERR_BOUND,ERR_NFOUND if can't
	virtual	t_err operator++(int)=0;
	virtual	t_err operator--(int)=0;

	// 
	virtual	Tlist_item_p operator-()=0;
	//    if NULL can happened error
	virtual	Tlist_item_p operator[](u_int index)=0;

	//     
	virtual u_int get_index()=0;

	//  
	virtual	u_int get_items()=0;
};

// ***********************************************************************
// ***********************************************************************
//  
class	Tplist_iterator:public Tplist_access,public Tlist_item
{
	friend class Tplist;

public:
	//    
	void operator+=(Tlist_item_p pointer);
	//    
	void operator-=(Tlist_item_p pointer);

	//   ERR_NFOUND if can't
	//   +1,  !exist  -1  
	t_err operator~();

	//     ERR_BOUND,ERR_NFOUND if can't
	t_err operator++(int);
	t_err operator--(int);

	// 
	Tlist_item_p operator-();
	//    if NULL can happened error
	Tlist_item_p operator[](u_int index);

	//     
	inline u_int get_index();

	//  
	inline u_int get_items();

	//   
	Tplist_iterator(Tplist& aplist);
	//   
	~Tplist_iterator();

protected:
	//     
	void	send_new_list();

	//  :  [0]
	char	no_longer_valid;
	// :   + setup no_longer_valid
	char	no_longer_exist;

	//  
	Tplist&	plist;

	// 
	Tplist_item_p	item;
	u_int		index;
};

// ***********************************************************************
//   
class	Tplist: public Tplist_access
{
public:

	//    
	inline void operator+=(Tlist_item_p pointer)
	 {(*access_p)+=pointer;}
	//    
	inline	void operator-=(Tlist_item_p pointer)
	 {(*access_p)-=pointer;}
	//   ERR_NFOUND if can't
	//   +1,  !exist  -1  
	inline	t_err operator~()
	 {return ~(*access_p);}

	//     ERR_BOUND,ERR_NFOUND if can't
	inline	t_err operator++(int)
	 {return (*access_p)++;}
	inline	t_err operator--(int)
	 {return (*access_p)--;}

	// 
	inline	Tlist_item_p operator-()
	 {return -(*access_p);}
	//    if NULL can happened error
	inline	Tlist_item_p operator[](u_int index)
	 {return (*access_p)[index];}

	//     
	inline	u_int get_index()
	 {return (*access_p).get_index();}

	//  
	inline	u_int get_items()
	 {return (*access_p).get_items();}

	//,  Tplist

	// 
	//virtual	t_err		save(FILE * fo);
	//virtual	t_err		load(FILE * fi);

	// 
	virtual	void	zap(char destruct_only=0);

	//  
	Tplist();
	~Tplist();

protected:
	//
	Tplist_item_p		list;
	// 
	Tplist_item_p		last;
	// 
	u_int			items;

	// :
	//virtual t_err load_header(FILE *fi);
	//virtual t_err save_header(FILE *fo);

private:

	Tplist_item_p	iterators;

	//   
	void	init_defaults();

	//  
	Tplist_iterator_p	access_p;

	//  
	friend class Tplist_iterator;
};

// ***********************************************************************
// ***********************************************************************
//     
inline	u_int Tplist_iterator::get_index()
{
	if(no_longer_valid)err2(ERR_DENIED,"   ");
	return index;
}

//  
inline u_int Tplist_iterator::get_items()
{
	if(no_longer_valid)err2(ERR_DENIED,"   ");
	return plist.items;
}

// ***********************************************************************
#endif
