#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "tstream\tstream.h"
#include "tstream\tfile.h"

// **********************************************************************
// 
// **********************************************************************
//  , / . . 
t_err 	Tfile_state::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=file_name.oos(OBJ_LOAD,fi))!=ERR_NO )
	   ||( (res=fs_unicode.oos(OBJ_LOAD,fi))!=ERR_NO )
	  )return res;

	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err   Tfile_state::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=file_name.oos(OBJ_SAVE,fo))!=ERR_NO )
	   ||( (res=fs_unicode.oos(OBJ_SAVE,fo))!=ERR_NO )
	  )return res;

	return ERR_NO;
}

// **********************************************************************
//  
// **********************************************************************
	Tfile::Tfile(char_p fname)
{
t_err		res;
	fi=NULL;
	need_close=0;

	if(fname)
	 {
	  res=open_file(fname);
	  if(res!=ERR_NO){err2(res,fname);return;}
	 }
}
// **********************************************************************
	Tfile::~Tfile()
{
	close_file();
}

// **********************************************************************
// 
// **********************************************************************
//  , / . . 
t_err 	Tfile::obj_load(FILE *fi)
{
t_err		res;
char		reopen;
u_int		pos;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tstream::obj_load(fi))!=ERR_NO )
	  )return res;

	//?  
	fread(&reopen,1,sizeof(reopen),fi);
	if(reopen)
	 {
	  Tstring fname(file_name);
	  if( (res=open_file(-fname))!=ERR_NO )return res;
	 }

	//  
	fread(&pos,1,sizeof(pos),fi);
	set_pos(pos);

	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err   Tfile::obj_save(FILE *fo)
{
t_err		res;
char		reopen;
u_int		pos;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=Tstream::obj_save(fo))!=ERR_NO )
	  )return res;

	//? ,   
	reopen=char(need_close?1:0);
	fwrite(&reopen,1,sizeof(reopen),fo);

	pos=get_pos();
	fwrite(&pos,1,sizeof(pos),fo);

	return ERR_NO;
}

// **********************************************************************
//  
// **********************************************************************
// 
t_err	Tfile::open_file(char_p fname)
{
	//  
	close_file();

	//?  
	if(!fname)return ERR_ZPAR;

	fi=fopen(fname,"rb");
	if(!fi)return ERR_FIO;

	need_close=1;
	file_name=fname;

	return ERR_NO;
}

// **********************************************************************
// 
void	Tfile::close_file()
{
	if((need_close)&&(fi))fclose(fi);
	need_close=0;

	fi=0;

	~file_name;
}

// **********************************************************************
//  
void	Tfile::assign_file(FILE *afi,char_p fname)
{
	//  
	close_file();

	fi=afi;
	file_name=fname;
}

// **********************************************************************
//  
FILE*   Tfile::get_file()
{
	return fi;
}

// **********************************************************************
//  
// **********************************************************************
//  
void	Tfile::set_pos(int pos,int whence)
{
	if(!fi)return;
	if(pos==EOF)
	 {
	  fseek(fi,0,SEEK_END);
	  fgetc(fi);
	 }
	else
	 fseek(fi,pos,whence);
}
// **********************************************************************
// 
u_int	Tfile::get_pos()
{
	if(!fi)return 0;
	return u_int(ftell(fi));
}
// **********************************************************************
// 
u_int	Tfile::fsize()
{
u_int		last_pos,file_size;
char		e=0;

	if(!fi)return 0;

	last_pos=get_pos();
	if(eof())e=1;

	set_pos(0,SEEK_END);
	file_size=get_pos();

	if(!e)set_pos(last_pos);
	else read_ch();

	return file_size;
}
// **********************************************************************
// " "
int	Tfile::eof()
{
	if(!fi)return 1;
	return feof(fi);
}
// **********************************************************************
// 
int	Tfile::read_ch()
{
int		ch;

	if(!fi)return EOF;

	ch=fgetc(fi);
	return (!eof())?unicode.convert(u_int(ch)):EOF;
}
// **********************************************************************
// 
int	Tfile::read_block( void* dst, u_int size )
{
u_int		i;
	if(!fi)return EOF;

	i=fread(dst,1,size,fi);
	return unicode.convert((char_p)dst,i);
}

// **********************************************************************

