#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "tstream\tstream.h"
#include "tstream\tstrfile.h"

/*
	       
*/

// **********************************************************************
//     
	TstringAsTfile::TstringAsTfile(Tstring_p new_str_p, u_int size)
{
	str_p=NULL;
	str_size=0;
	str_pos=0;
	f_eof=0;

	if(new_str_p)
	 {
	  //warn("here");
	  assign_string(*new_str_p,size);
	 }
/*
	{
	 char s[80];
	 sprintf(s,"fsize %u,fpos %u,%cEOF",fsize(),get_pos(),char(eof()?' ':'!'));
	 warn(s);
	}
*/
}

// **********************************************************************
// 
// **********************************************************************
//   , / . . 
t_err	TstringAsTfile::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);


	if( (res=Tstream::obj_load(fi))!=ERR_NO )
	 return res;

	str_p=NULL;
	str_size=0;
	str_pos=0;
	f_eof=0;

	return ERR_NO;
}

// **********************************************************************
//   , / . . 
t_err 	TstringAsTfile::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if( (res=Tstream::obj_save(fo))!=ERR_NO )
	 return res;

	return ERR_NO;
}

// **********************************************************************
//  
// **********************************************************************
//  
void	TstringAsTfile::assign_string(Tstring& str, u_int size)
{
	str_p=&str;
	str_size=size?size:str.len();
	str_pos=0;
	f_eof=0;
/*
	{
	 char s[80];
	 sprintf(s,"str_size %u,size %u,len %u",fsize(),size,str.len());
	 warn(s);
	}
*/
}

// **********************************************************************
//  
// **********************************************************************
//  
void 	TstringAsTfile::set_pos(int pos,int whence)
{
u_int		u;

	if(!str_p)return;
	u=pos;
	f_eof=0;

	switch(whence)
	 {
	  case SEEK_SET:
	   str_pos=(pos<=0)?0:
		    ( (u >= str_size)?str_size:pos );
	   break;

	  case SEEK_END:
	   str_pos= (!pos)?
		     str_size:
		     //(str_size?str_size-1:0):
		     ( (pos>0)?str_size:
		      ( (u_int(-pos) >= str_size )?0:str_size-u_int(-pos) )
		     );
	   break;

	  case SEEK_CUR:
	   if(!pos)break;
	   str_pos=(pos<0)?
		    ( ( u_int(-pos) >= str_pos )?0:str_pos-u_int(-pos) ):
		    ( ((u+str_pos) >= str_size)?str_size:pos+str_pos );
	   break;

	  default:
	   {
	    char s[80];
	    sprintf(s,"bad whence '%u'",whence);
	    err2(ERR_BADPAR,s);
	    return;
	   }
	 }
}

// **********************************************************************
// 
u_int	TstringAsTfile::get_pos()
{
	if(!str_p)return EOF;
	if(eof())return EOF;
	if(str_pos>=str_size)return str_size;
	return str_pos;
}

// **********************************************************************
// 
u_int	TstringAsTfile::fsize()
{
	if(!str_p)return 0;
	return str_size;
}
// **********************************************************************
// " "
int	TstringAsTfile::eof()
{
	if(!str_p)return 1;
	return f_eof;
}

// **********************************************************************
// 
int	TstringAsTfile::read_ch()
{
	if(!str_p)return EOF;

	if(str_pos>=str_size)
	 {
	  f_eof=1;
	  return EOF;
	 }

	return unicode.convert( u_int(*((-*str_p)+ str_pos++)) );
}

// **********************************************************************
// 
int	TstringAsTfile::read_block( void* dst, u_int size )
{
u_int		i;

	if(!dst){err(ERR_ZPAR);return 0;}

	if((!str_p)
	   ||(!size)
	  )return 0;

	if(str_pos>=str_size)
	 {
	  f_eof=1;
	  return 0;
	 }

	i=str_size-str_pos;
	if(size<i)i=size;

	memcpy(dst,(-*str_p)+ str_pos,i);
	unicode.convert(char_p(dst),i);
	str_pos+=i;
	return i;
}

// **********************************************************************
