#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#include <keyb\keyb.h>

#include <classes\plist.h>

#pragma hdrstop
#include "easywin.h"
//#include "c:\bc45\prj\easywin\easywin.h"

// ****************************************************************
// ****************************************************************
//
	Tdesktop::Tdesktop(Tkeyb_p akeyb_p)
{
	_wscroll=0;

	if(akeyb_p)
	 {
	  keyb_p=akeyb_p;
	  need_free_keys=0;
	 }
	else
	 {
	  keyb_p=new Tkeyb;
	  if(!keyb_p){err(ERR_NOMEM);return;}
	  need_free_keys=1;
	 }
	resolution(C80);
}

// ****************************************************************
	Tdesktop::~Tdesktop()
{
	//  
	if(need_free_keys)
	 {
	  delete keyb_p;
	  keyb_p=NULL;
	 }
}

// ****************************************************************
//
//  :    
//   ,  cx,cy ->u_int     
//  :  
void 	Tdesktop::print(char_p str)
{
char		s[DESKTOP_MAX_LX+8];
u_int		line,len;

	if(!str){err(ERR_ZPAR);return;}
	if( !(len=strlen(str)) )return;

	if(len>DESKTOP_MAX_LX)
	 {
	  char s[160];
	  sprintf(s,"Tdesktop::print\n'%u' line truncated to '%u'", len, DESKTOP_MAX_LX);
	  warn(s);
	  len=DESKTOP_MAX_LX;
	 }

	if(
	   (cx>=lx)
	   ||(cy>=ly)
	  )return;

	line=lx-cx;
	len=my_min(len,line);

	memcpy(s,str,len);
	*(s+len)=0;

	cprintf("%s",s);
}

// ****************************************************************
// 
t_err	Tdesktop::set_cursor_type(int type)
{
	switch(type)
	 {
	  case _NOCURSOR:
	  case _NORMALCURSOR:
	  case _SOLIDCURSOR:
	   break;

	  default:
	   {
	    char s[80];
	    sprintf(s,"Bad cursor type '%u'",type);
	    return err2(ERR_BADPAR,s);
	   }
	 }
	cursor_type=type;
	_setcursortype(type);
	return ERR_NO;
}

// ****************************************************************
//set new mode
t_err	Tdesktop::resolution(int mode)
{
struct text_info 	r;

	switch(mode)
	 {
	  case C80:
	  case C4350:
	  break;

	  default:
	   {
	    char s[80];
	    sprintf(s,"Bad resolution mode '%u'",mode);
	    return err2(ERR_BADPAR,s);
	   }
	 }
	textmode(mode);

	gettextinfo(&r);
	lx=r.screenwidth;
	ly=r.screenheight;

	gotoxy(0,0);
	set_cursor_type();
	return ERR_NO;
}

// ****************************************************************

