#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#include <keyb\keyb.h>

#include <classes\plist.h>

#pragma hdrstop
#include "easywin.h"
//#include "c:\bc45\prj\easywin\easywin.h"

// ****************************************************************
// 
// ****************************************************************
//     
class	Twin_prepare_print
{
private:
	Twin&	win;
public:
	//  
	char	s[DESKTOP_MAX_LX+8];

	//  lines  x,y
	u_int	sx,sy;
	// 
	u_int	cx,cy;
	// 
	u_int	vis_lx,vis_ly;

	//  
	Twin_prepare_print(Twin& awin):win(awin){}

	// 
	char	setup(int x,int y);

	//    
	void	setline()
	 {
	  textcolor(win.color);
	  textbackground(win.bkcolor);

	  if(vis_lx>DESKTOP_MAX_LX){err2(ERR_BOUND,"line too long");return;}

	  memset(s,' ',vis_lx);
	  *(s+vis_lx)=0;
	 }

	void	debug_print();
};

// ****************************************************************
// 
char	Twin_prepare_print::setup(int x,int y)
{
	// 
	sx=sy=0;
	cx=cy=0;
	vis_lx=vis_ly=0;

	//check win size exist
	if((!win.lx)||(!win.ly))return 0;

	//     
	if(x<0)sx=-x; else cx=x;
	if(y<0)sy=-y; else cy=y;

	//check cx,cy out of range =>      
	if(
	   (cx >= win.desktop_p->lx )
	   ||(cy >= win.desktop_p->ly )
	  )return 0;

	//   : ?left bound over
	if(sx)
	 {
	  //   !
	  if(win.lx>sx)vis_lx=win.lx-sx;
	 }
	else vis_lx=win.lx;

	//   y: ?up bound over
	if(sy)
	 {
	  //   !
	  if(win.ly>sy)vis_ly=win.ly-sy;
	 }
	else vis_ly=win.ly;

	//check win visible size exist
	if((!vis_lx)||(!vis_ly))return 0;

	return 1;
}

// ****************************************************************
void	Twin_prepare_print::debug_print()
{
char		p[1024];

	sprintf(p,"Twin_prepare_print::[%p]\n\
win=[%p]\
\nstrlen(s)=%u\
\nsx,sy=(%u,%u)\
\ncx,cy=(%u,%u)\
\nvis_lx,vis_ly=(%u,%u)\
",this,&win, (s)?strlen(s):0,sx,sy,cx,cy,vis_lx,vis_ly );
	//warn(p);
	MessageBox(0,p,"debug",MB_APPLMODAL|MB_OK);
}

// ****************************************************************
// O
// ****************************************************************
//desktop
Tdesktop_p Twin::desktop_p=NULL;
// desktop     
char	Twin::need_free_desktop=0;
// 
u_int	Twin::instances=0;

// ****************************************************************
	Twin::Twin()
{
	if(!desktop_p)
	 {
	  desktop_p=new Tdesktop;
	  if(!desktop_p){err(ERR_NOMEM);return;}
	  need_free_desktop=1;
	 }

	if(instances==-1){err2(ERR_DENIED,"can't create more Twin");return;}
	instances++;

	color=GREEN;
	bkcolor=BLACK;
	//unhide all
	hide(0);

	is_active=0;
	last_x=last_y=0;

	lx=desktop_p->lx;
	ly=desktop_p->ly;
}

// ****************************************************************
	Twin::~Twin()
{
	//warn("Twin::~Twin()");

	// -
	if(is_active)sw_active();

	//  
	{
	 u_int			i,j;
	 Twin_list_item_p	p;

	   children[0];
	   j=children.get_items();

	   for( i=0; i<j; i++ )
	    {
	     p=(Twin_list_item_p)-children;
	     if(
		(p)
		&&(p->win_need_free)
	       )
	      {
	       delete &(p->win);
	       p->win_need_free=0;
	      }
	     children++;
	    }
	}

	//   
	instances--;
	if(
	   (!instances)
	   &&(need_free_desktop)
	   &&(desktop_p)
	  )
	 {
	  delete desktop_p;
	  desktop_p=NULL;
	  need_free_desktop=0;
	 }
}

// ****************************************************************
///   
//default: 0/1 hide/unhide all
void	Twin::hide(char type)
{
	hide_self=hide_children=type;
}

// ****************************************************************
//  desktop
//    ,     
void 	Twin::set_resolution(int mode)
{
	desktop_p->resolution(mode);
	set_size(desktop_p->lx,desktop_p->ly);
}

// ****************************************************************
//   -    
void 	Twin::set_size(u_int new_lx,u_int new_ly)
{
u_int			i;
Twin_list_item_p	p;

	//  
	children[0];
	for( i=0; i<children.get_items(); i++ )
	 {
	  p=(Twin_list_item_p)-children;
	  if(p)
	   {
	    p->win.set_size(new_lx,new_ly);
	   }
	  children++;
	 }
}

// ****************************************************************
//   
void	Twin::sw_active()
{
u_int			i;
Twin_list_item_p	p;

	//  
	children[0];
	for( i=0; i<children.get_items(); i++ )
	 {
	  p=(Twin_list_item_p)-children;
	  if(p)p->win.sw_active();
	  children++;
	 }
}

// ****************************************************************
//      desktop
void	Twin::set_reference(int x, int y)
{
	//    desktop
	last_x=x;
	last_y=y;

	while(1)
	 {
	  //   ?  
	  if(hide_children)break;

	  u_int			i;
	  Twin_list_item_p	p;

	  children[0];
	  for( i=0; i<children.get_items(); i++ )
	   {
	    p=(Twin_list_item_p)-children;
	    if(p)p->win.set_reference(x+p->x,y+p->y);
	    children++;
	   }
	  break;
	 }
}

// ****************************************************************
//rerdraw win from positions on desktop
void	Twin::refresh()
{
u_int			i;
Tstring_p		p;
Twin_prepare_print	par(*this);


	while(1)
	 {
	  //?   
	  if(hide_self)break;

	  //   
	  if(!par.setup(last_x,last_y))break;

	  //par.debug_print();

	  //reset list
	  lines[0];

	  //print list from position
	  lines[par.sy];

	  //p= new Tstring;
	  //if(!p){err(ERR_NOMEM);return;}

	  //    
	  for(i=0; i<par.vis_ly; i++)
	   {
	    //    
	    par.setline();

	    //check sy ( ) not out of range
	    if( par.sy < lines.get_items() )
	     {
	      p=(Tstring_p)-lines;
	      if(
		 (p)
		 &&( p->len() > par.sx )
		)
	       {
		u_int	len;

		//  
		len=u_int(p->len())-par.sx;
		//       \0:
		//       
		memcpy(par.s,(-*p)+par.sx,my_min( len, par.vis_lx));
	       }

	      lines++;
	      par.sy++;
	     }

	    // & clear
	    desktop_p->printxy(par.cx,par.cy++,par.s);
	   }
	  break;
	 }

	while(1)
	 {
	  //   ?  
	  if(hide_children)break;

	  u_int			i;
	  Twin_list_item_p	p;

	  children[0];
	  for( i=0; i<children.get_items(); i++ )
	   {
	    p=(Twin_list_item_p)-children;
	    if(p)p->win.refresh(last_x+p->x,last_y+p->y);
	    children++;
	   }
	  break;
	 }
}

// ****************************************************************
//clear win from positions on desktop
void	Twin::clear()
{
u_int			i;
Twin_prepare_print	par(*this);

	while(1)
	 {
	   //?   
	   if(hide_self)break;

	   //   
	   if(!par.setup(last_x,last_y))break;

	   //    
	   par.setline();

	   //    
	   for(i=0; i<par.vis_ly; i++)
	    {
	     //clear line
	     desktop_p->printxy(par.cx,par.cy++,par.s);
	    }
	   break;
	 }

	while(1)
	 {
	  //   ?  
	  if(hide_children)break;

	  u_int			i;
	  Twin_list_item_p	p;

	  children[0];
	  for( i=0; i<children.get_items(); i++ )
	   {
	    p=(Twin_list_item_p)-children;
	    if(p)p->win.clear(last_x+p->x,last_y+p->y);
	    children++;
	   }

	  break;
	 }
}

// ****************************************************************

