#ifndef EASYWIN_H
#define EASYWIN_H

// ****************************************************************
// ****************************************************************
//
class	Tdesktop;
typedef Tdesktop *Tdesktop_p;
//
class	Twin;
typedef	Twin *Twin_p;
//  
class	Twin_list_item;
typedef Twin_list_item *Twin_list_item_p;

// ****************************************************************
// ****************************************************************
//
class	Tdesktop
{
public:
	inline void gotoxy(u_int x, u_int y)
	 {::gotoxy(x+1,y+1);cx=x;cy=y;}

	inline void printxy(u_int x, u_int y, char_p str)
	 {gotoxy(x,y); print(str);}

	//
	//  :    
	//   ,  cx,cy ->u_int     
	//  :  
	void print(char_p str);

	//set new desktop resolution
	t_err	resolution(int mode);

	// 
	t_err	set_cursor_type(int type=_NOCURSOR);

	Tdesktop(Tkeyb_p akeyb_p=NULL);
	virtual ~Tdesktop();

	//current screen resolution
	u_int	lx,ly;
	//cursor position from 0 have set by gotoxy
	u_int	cx,cy;

	//global keyboard
	Tkeyb_p	keyb_p;

protected:
	//    
	char	need_free_keys;

	int	cursor_type;
};
//      
#define DESKTOP_MAX_LX 1024

// ****************************************************************
// ****************************************************************
/*
Wanted:   __:
	        
*/
// ****************************************************************
// ****************************************************************
//
class	Twin
{
public:
	//       
	// set_size,clear,refresh,sw_active
	//    
	//         hide_XXX
	Tplist	children;

	//     print,clear
	char	hide_self;
	//     print,clear
	char	hide_children;
	///   
	//default: 1/0 hide/unhide all
	virtual void hide(char type);

	// 
	Tplist	lines;

	//   desktop
	int	last_x,last_y;
	//win size
	u_int	lx,ly;
	//   -    
	virtual void set_size(u_int lx,u_int ly);
	//      desktop
	virtual void set_reference(int x, int y);
	//  desktop
	//    ,     
	virtual void set_resolution(int mode);

	//
	int	color,bkcolor;
	//clear win from positions on desktop
	virtual void clear();
	inline  void clear(int x, int y)
	 {set_reference(x,y);clear();}
	//rerdraw win from positions on desktop
	virtual void refresh();
	inline  void refresh(int x, int y)
	 {set_reference(x,y);refresh();}

	//  
	char	is_active;
	//   
	virtual void sw_active();

	//
	Twin();
	virtual ~Twin();

	//desktop
	static Tdesktop_p desktop_p;

protected:
	// desktop     
	static char	need_free_desktop;
	//    Twin
	static u_int	instances;

private:
	//internal
	friend class Twin_prepare_print;
};

// ****************************************************************
// ****************************************************************
// 
class	Twin_list_item: public Tlist_item
{
public:
	//   
	int	x,y;
	//  
	Twin&	win;

	//      
	char	win_need_free;

	//   
	inline Twin_list_item(Twin& awin, char awin_need_free=1 ):win(awin)
	 {
	  x=y=0;
	  win_need_free=awin_need_free;
	 }

protected:
};

// ****************************************************************
#endif
