#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#pragma hdrstop

//#include "keys.h"
#include "keyb.h"

/* ******************************************************************* */
// : ext:ascii
/* ******************************************************************* */
//  
	Tkeyb_actions::Tkeyb_actions()
{
	  //  
	  clear();
}

/* ******************************************************************* */
//  
void	Tkeyb_actions::clear(Tkeyb_action& keyb_action)
{
Tkeyb_action_p		p;
u_int			i;

	  p=(Tkeyb_action_p)actions;
	  for(i=0;i<2*256; i++) *p++=keyb_action;
}

/* ******************************************************************* */
//
/* ******************************************************************* */
//    
	Tkeyb::Tkeyb(Tkeyb_actions_p actions_p)
{
	if(!actions_p)/*   DEF_ACTION */
	 {
	  // 
	  keyb_actions_p=new Tkeyb_actions;
	  if(!keyb_actions_p){err(ERR_NOMEM);return;}
	  need_free_mem=1;
	 }
	else
	 {
	  need_free_mem=0;
	  keyb_actions_p=actions_p;
	 }
}

/* ******************************************************************* */
	Tkeyb::~Tkeyb()
{
	if(need_free_mem)
	 {
	  delete keyb_actions_p;
	  keyb_actions_p=NULL;
	 }
}

/* ******************************************************************* */
//      
/* ******************************************************************* */
//    /
t_err	Tkeyb::action(int wait)
{
Tkeyb_key	key;

	if(wait==KEYB_ACTION_NOWAIT)if(!kbhit())return ERR_NFOUND;

	// ext:ascii
	key.ext=KEY_ASCII;
	key.ascii=(char)getch();
	if(!key.ascii)
	 {
	  key.ext=KEY_EXT;
	  key.ascii=(char)getch();
	 }

	return exec(key);
}

/* ******************************************************************* */
//   o| 
t_err	Tkeyb::exec(Tkeyb_key key)
{
Tkeyb_action	action;

	if(abs(key.ext)>KEY_EXT)return err(ERR_BOUND);

	last_key=key;
	action=get_installed(key);

	//?  
	if( action.action_f==KEYB_DEF_ACTION_F)return ERR_ZDATA;

	(*(action.action_f))( key, action.obj_p );
	return ERR_NO;
}

/* ******************************************************************* */
//    
Tkeyb_key Tkeyb::get_last_key()
{
	return last_key;
}

/* ******************************************************************* */
//     
/* ******************************************************************* */
/*    | */
t_err	Tkeyb::install( Tkeyb_key key, Tkeyb_action& new_action )
{
	if(abs(key.ext)>KEY_EXT)return err(ERR_BOUND);

	(keyb_actions_p->actions)[key.ext][key.ascii]=new_action;
	return ERR_NO;
}

/* ******************************************************************* */
//     */
Tkeyb_action Tkeyb::get_installed( Tkeyb_key key )
{
	if(abs(key.ext)>KEY_EXT){err(ERR_BOUND);return KEYB_DEF_ACTION;}

	return (keyb_actions_p->actions)[key.ext][key.ascii];
}

/* ******************************************************************* */
/*    ext|ascii */
Tkeyb_action	Tkeyb::replace( Tkeyb_key key, Tkeyb_action& new_action )
{
Tkeyb_action	old_action;
t_err		ret;

	if(abs(key.ext)>KEY_EXT){err(ERR_BOUND);return KEYB_DEF_ACTION;}

	old_action=get_installed(key);
	ret=install(key,new_action);

	if(ret !=ERR_NO){err(ret);return NULL;}
	return old_action;
}

/* ******************************************************************* */
//  
Tkeyb_actions_p Tkeyb::get_keyb_actions()
{
	return keyb_actions_p;
}

/* ******************************************************************* */
