#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mydef.h>

#include "keys.h"
#include "keytbl.h"
/*
	keytbl   - load
*/

//load global keytbl_tbl from keytbl_file
t_err	_far	keytbl_load(char_p fname,t_keytbl_file& keytbl_file)
{
FILE	*fi;
u_int	fs;

	if(!fname)return err(ERR_ZPAR);
	if(!strlen(fname))return err(ERR_ZDATA);

	fi=fopen(fname,"rb");
	if(!fi)return err2(ERR_FIO,fname);

	//fsize
	fseek(fi,0,SEEK_END);
	fs=(u_int)ftell(fi);
	fseek(fi,0,SEEK_SET);

	if(fs!=sizeof(t_keytbl_file))
	 {
	  char s[80];
	   sprintf(s,"   '%u',  '%u'",fs,sizeof(t_keytbl_file));
	   return err2(ERR_FIO,s);
	 }

	//sign
	fread(&keytbl_file.sign[0],1,KEYTBL_FILE_SIGN_LEN,fi);

	//version
	fread(&keytbl_file.version,1,2,fi);
	if(keytbl_file.version!=KEYTBL_FILE_VERSION)
	 {
	  char s[80];
	   sprintf(s,"  '%u',  '%u'",keytbl_file.version,KEYTBL_FILE_VERSION);
	   return err2(ERR_FIO,s);
	 }

	//data
	fread(&keytbl_file.tbl[0][0],1,sizeof(t_keytbl_tbl),fi);

	fclose(fi);
	return ERR_NO;
}

/* *************************************************************** */
