#include <stdio.h>
#include <stdlib.h>

#include <windows.h>
#include "mydef.h"

// ***********************************************************************
// what do on error
char	on_err=ONERR_HALT;

static	HWND	err_module=0;

// ***********************************************************************
//   -    TWinMain
void	init_err(HWND module)
{
	err_module=module;
}

// ***********************************************************************
char_p	strerr(t_err err)
{
static	char	s[40];

	switch(err)
	 {
          case ERR_NO:		return "no errors";
	  case ERR_NOMEM:	return "no more memory";
	  case ERR_FIO:         return "file operation";
	  case ERR_BOUND:       return "bound over";
	  case ERR_BADPAR:      return "bad parameter/request";
	  case ERR_ZPAR:        return "zero parameter/pointer";
	  case ERR_ZDATA:       return "zero data field";
	  case ERR_NFOUND:	return "not found";
	  case ERR_NEXIST:	return "not exist";
	  case ERR_INTERNAL:	return "internal";
	  case ERR_ALREADY:	return "already exist/set";
	  case ERR_BUZY: 	return "buzy";
	  case ERR_UNDEF:       return "undefined";
	  case ERR_BP:          return "break point";
	  case ERR_DENIED:	return "access denied";
	  case ERR_BADVER:	return "bad version";
          case ERR_BADFORMAT:	return "bad format";
	  default:
	    sprintf(s,"unknown code '%u'",err);
	    return s;
	 }
}

// ***********************************************************************
#define	ERRW32_MAX_MSG_SIZE	(50)
t_err	errw32_(t_err err, char_p f, u_int l, char_p msg )
{
static	char	buf[196];

	buf[0]=0;
	//error description
	if(msg)
	 {
	  strcpy(buf,"MSG: ");
	  memcpy(buf+strlen(buf),msg,ERRW32_MAX_MSG_SIZE);
	  buf[5+ERRW32_MAX_MSG_SIZE]=0;
	 }

	if(err!=ERR_NO)
	 {
	  sprintf( buf+strlen(buf),
		    "\nERROR: %s",
		    strerr(err)
		   );
	 }

	sprintf( buf+strlen(buf),
		 "\nat file '%s', line '%u'",
		 f,l
		);

	//no error code -display msg and return
	if(err==ERR_NO)
	 {
	  //display msg
	  MessageBox( err_module,buf,"Warning",
		      MB_OK | MB_TASKMODAL | MB_ICONEXCLAMATION
		     );
	  return err;
	 }

	//what do on error
	switch(on_err)
	 {
	  case ONERR_GO:
	   {
	    sprintf( buf+strlen(buf),
		    "\nPress OK to continue."
		  );

	    MessageBox( err_module,buf,"Error",
			MB_OK | MB_TASKMODAL | MB_ICONSTOP
		       );
	   }break;

	  case ONERR_HALT:
	   {
	    sprintf( buf+strlen(buf),
		       "\nHALT on error."
		     );

	    MessageBox( err_module,buf,"Error",
			 MB_OK | MB_TASKMODAL | MB_ICONSTOP
			);
	    exit(err);

	   }break;

	  default:
	   {
	    sprintf( buf+strlen(buf),
		       "\n'on_err' wrong set '%u'.\nHalted.",
		       on_err
		     );

	    MessageBox( err_module,buf,"Error",
			  MB_OK | MB_TASKMODAL | MB_ICONSTOP
			);
	    exit(err);

	   }
	 }

	return err;
}

// ***********************************************************************

