#include "lbrouser\all.h"

#include "winitems.h"
//#include "lbrouser\lbrouser.h"
#include "lbrouser\lbpaper.h"

// **********************************************************************
	Tlbpaper::Tlbpaper()
{
	base_line=0;
	sx=0;
	filter_p=0;

	color=BLACK;
	bkcolor=WHITE;

	en_sw_wrap=1;
	en_sw_hex=1;
}

// **********************************************************************
	Tlbpaper::~Tlbpaper()
{
	//  
	zap();
}

// **********************************************************************
//   
// **********************************************************************
//   -    
void 	Tlbpaper::set_size(u_int new_lx,u_int new_ly)
{

	lx=new_lx;
	ly=new_ly;

	if(filter_p)
	 {
	  //  
	  filter_p->line_discipline(lx);

	  if(filter_p->seek(base_line)!=ERR_NO)
	   {
	    filter_p->seek(0);
	    base_line=0;
	   }

	  //     Tmeta
	  set_page();
	 }

	//children
	Twin::set_size(lx,ly);
}

// **********************************************************************
//   e 
// **********************************************************************
//  
void	Tlbpaper::set_filter(Tlnmeta_mode_lnstream& filter)
{
	filter_p=&filter;

	//  
	filter.line_discipline(lx);
}

// **********************************************************************
// :     Tstrings
void	Tlbpaper::zap()
{
u_int		i,j;
Tlist_item_p	p;

	lines[0];
	j=lines.get_items();
	for(i=0;i<j;i++)
	 {
	  p=-lines;
	  delete p;
	  lines++;
	 }
	lines.zap();
}
// **********************************************************************
//    sx
static Tstring_p adjust_by_sx(Tstring& src, int sx)
{
u_int		len;
Tstring_p	t;

	t=&src;
	len=t->len();
	if(len)
	 {
	  if(sx>0)
	   {
	    t=new Tstring(0,sx+len);
	    if(!t){err(ERR_NOMEM);return 0;}

	    memset(-*t,' ',sx);
	    *((-*t)+sx)=0;
	    (*t)+=src;

	    delete &src;
	   }
	  else if(sx<0)
	   {
	    //?    
	    if( len <= u_int(-sx))*(-src)=0;
	    else memmove(-src,-src+u_int(-sx),len-u_int(-sx)+1);
	   }
	 }
	return t;
}

// **********************************************************************
//     Tmeta
void	Tlbpaper::set_page()
{
u_int		i;
Tstring_p	p;

	if(!filter_p)return;

	//    Tstrings
	zap();

	lines[0];
	for(i=0;i<ly;i++)
	 {
	  p=filter_p->read();
	  if(!p)break;

	  //   
	  p=adjust_by_sx(*p,sx);
	  lines+=(Tlist_item_p)p;
	 }
}

// **********************************************************************
//    
// **********************************************************************
void	Tlbpaper::up()
{
Tstring_p	p;

	if(!filter_p)return;

	if(!base_line)return;

	if(filter_p->seek(base_line-1)!=ERR_NO)return;
	base_line-=1;

	//    Tstrings
	lines[0];
	if(
	   (lines.get_items())
	   &&(lines.get_items()>=ly)
	  )
	 {
	  lines[lines.get_items()-1];
	  if(-lines)delete -lines;
	  ~lines;
	  lines[0];
	 }

	//     Tmeta
	p=filter_p->read();
	if(p)
	 {
	  //   
	  p=adjust_by_sx(*p,sx);
	  lines-=(Tlist_item_p)p;
	 }

	//
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tlbpaper::dn()
{
Tstring_p	p;

	if(!filter_p)return;
	if(filter_p->seek(base_line+1)!=ERR_NO)return;
	base_line+=1;

	//    Tstrings
	lines[0];
	if(lines.get_items())
	 {
	  if(-lines)delete -lines;
	  ~lines;
	  if(lines.get_items())lines[lines.get_items()-1];
	 }

	//     Tmeta
	if(filter_p->seek(base_line+ly-1)==ERR_NO)
	 {
	  p=filter_p->read();
	  if(p)
	   {
	    //   
	    p=adjust_by_sx(*p,sx);
	    lines+=(Tlist_item_p)p;
	   }
	 }

	//
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tlbpaper::pg_up()
{
u_int		ly2;

	if(!filter_p)return;

	ly2=(ly>3)?ly-2:ly;

	if(base_line<=ly2)
	 {
	  if(!base_line)return;
	  base_line=0;
	  filter_p->seek(0);
	 }
	else
	 {
	  if(filter_p->seek(base_line-ly2)!=ERR_NO)return;
	  base_line-=ly2;
	 }

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tlbpaper::pg_dn()
{
u_int		ly2;

	if(!filter_p)return;

	ly2=(ly>3)?ly-2:ly;

	if(filter_p->seek(base_line+ly2)!=ERR_NO)return;
	base_line+=ly2;

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tlbpaper::home()
{
	if(!filter_p)return;

	filter_p->seek(0);
	base_line=0;

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tlbpaper::end()
{
	if(!filter_p)return;

	//   
	base_line=filter_p->get_lines();
	if(base_line > ly)base_line-=ly;
	else base_line=0;

	filter_p->seek(base_line);

/*	while(1)
	 {
	  if(filter_p->seek(base_line+ly)!=ERR_NO)break;
	  base_line+=ly;
	 }*/

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::up10()
{
u_int		n;
double		f;

	if(!filter_p)return;

	if(!base_line)return;

	f=filter_p->get_lines();
	f/=10.0;
	n=f;
	if(!n)n=1;

	if(n>base_line)base_line=0;
	else base_line=base_line-n;

	filter_p->seek(base_line);

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::dn10()
{
u_int		n;
double		f;

	if(!filter_p)return;

	f=filter_p->get_lines();
	f/=10.0;
	n=f;
	if(!n)n=1;

	n+=base_line;

	if(filter_p->seek(n)!=ERR_NO){end();return;}
	base_line=n;

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tlbpaper::lf()
{
	if(!filter_p)return;

	sx++;
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::rt()
{
	if(!filter_p)return;

	sx--;
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::lf_pg()
{
	if(!filter_p)return;

	sx+=int(lx);
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::rt_pg()
{
	if(!filter_p)return;

	sx-=int(lx);
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::lf_home()
{
	if(!filter_p)return;

	sx=0;
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::rt_end()
{
}
// **********************************************************************
void	Tlbpaper::lf_tab()
{
	if(!filter_p)return;

	sx+=8;
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}
// **********************************************************************
void	Tlbpaper::rt_tab()
{
	if(!filter_p)return;

	sx-=8;
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************
//      
//   
void	Tlbpaper::sync_by_stream()
{
	if(!filter_p)return;

	base_line=filter_p->get_last_seek();
	if(filter_p->seek(base_line)!=ERR_NO){home();return;}

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************
// 
// **********************************************************************
void	Tlbpaper::sw_wrap()
{
Tlnmeta_mode_p		p;
u_int			mode_number;

	if(!filter_p)return;
	if(!en_sw_wrap)return;

	if(filter_p->get_submode_number()!=LNMETA_MODE_TEXT)return;

	//     
	if(filter_p->seek(base_line)!=ERR_NO)
	 {
	  filter_p->seek(0);
	  base_line=0;
	 }

	// 
	p=filter_p->get_submode();
	if(!p)return;

	switch(p->get_submode_number())
	 {
	  case LNMETA_MODE_UNWRAP:
	   mode_number=LNMETA_MODE_WRAP;
	  break;

	  case LNMETA_MODE_WRAP:
	   mode_number=LNMETA_MODE_WORDWRAP;
	  break;

	  case LNMETA_MODE_WORDWRAP:
	   mode_number=LNMETA_MODE_UNWRAP;
	  break;

	  default:
	   mode_number=LNMETA_MODE_UNWRAP;
	 }

	p->set_submode_number(mode_number);
	Tlnmeta_mode_lnstream_p(p)->line_discipline(lx);

	//     
	base_line=filter_p->get_line();
	//     
	if(filter_p->seek(base_line)!=ERR_NO)
	 {
	  filter_p->seek(0);
	  base_line=0;
	 }

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tlbpaper::sw_hex()
{
	if(!filter_p)return;
	if(!en_sw_hex)return;

	//     
	if(filter_p->seek(base_line)!=ERR_NO)
	 {
	  filter_p->seek(0);
	  base_line=0;
	 }
	// 
	filter_p->set_submode_number(
	 (filter_p->get_submode_number()==LNMETA_MODE_HEX)?
	 LNMETA_MODE_TEXT:LNMETA_MODE_HEX
				 );

	//     
	base_line=filter_p->get_line();
	//     
	if(filter_p->seek(base_line)!=ERR_NO)
	 {
	  filter_p->seek(0);
	  base_line=0;
	 }

	//     Tmeta
	set_page();
	//
	refresh(last_x,last_y);
}

// **********************************************************************

