#include "vbrouser\all.h"

#include "winitems.h"
#include "vbrouser\vbrouser.h"
#include "vbrouser\vbpaper.h"

// **********************************************************************
// 
// **********************************************************************
//      
class	Tvbpaper_mark_line;
typedef Tvbpaper_mark_line *Tvbpaper_mark_line_p;

// **********************************************************************
//       VBROUSER
// **********************************************************************
class	Tvbpaper_mark_line: public Twin
{
public:
	inline	Tvbpaper_mark_line()
	 {
	  color=WHITE;
	  bkcolor=CYAN;
	 }

//   
public:
	//   -    
	void 	set_size(u_int lx,u_int ly);
};

// **********************************************************************
//   -    
void 	Tvbpaper_mark_line::set_size(u_int new_lx,u_int new_ly)
{
	lx=new_lx;
	ly=(new_ly)?1:0;

	Twin::set_size(lx,ly);
}

// **********************************************************************
//<START>
// 
// **********************************************************************
//  by default
	Tvbpaper::Tvbpaper()
{
Tvbpaper_mark_line_p	w;
Twin_list_item_p	p;

	//  -  
	w=new Tvbpaper_mark_line;
	if(!w){err(ERR_NOMEM);return;}

	p=new Twin_list_item(*w);
	if(!p){err(ERR_NOMEM);return;}
	children+=p;

	//   
	info_p=0;
	selected_line=0;
	base_line=0;

	color=BLACK;
	bkcolor=WHITE;
}

// **********************************************************************
//   
// **********************************************************************
//   -    
void 	Tvbpaper::set_size(u_int new_lx,u_int new_ly)
{
	lx=new_lx;
	ly=new_ly;

	Twin::set_size(lx,ly);
}

// **********************************************************************
//   
// **********************************************************************
//   
void	Tvbpaper::set_page()
{
u_int			i,j;
Twin_list_item_p	p;

	//     
	p=(Twin_list_item_p)children[0];
	if(!p){err2(ERR_ZDATA,"child list error");}

	//    
	lines.zap();
	//?  
	if(!info_p)
	 {
	  //    
	  p->win.hide(1);
	  return;
	 }

	//    
	p->win.hide(0);
	//   
	p->win.lines.zap();

	//     
	(*info_p)[0];
	//      
	j=(*info_p).get_items();
	if(selected_line >= j)
	 {
	  selected_line=j?j-1:0;
	  base_line=selected_line;
	  p->y=0;
	  if(!j)return;
	 }

	//  vbrouser-   base_line
	(*info_p)[base_line];

	for(i=0;i<ly;i++)
	 {
	  if((base_line+i) >= j)break;

	  if(i==p->y)
	   p->win.lines+=-(*info_p);

	  lines+=-(*info_p);
	  lines++;
	  (*info_p)++;
	 }
}
// **********************************************************************
//    
void	Tvbpaper::set_list_for_select(Tplist& info, u_int preselected)
{
u_int		new_selected;
Twin_list_item_p	p;

	//  
	p=(Twin_list_item_p)children[0];
	if(!p){err2(ERR_ZDATA,"child list error");}

	//  
	if(info_p)delete info_p;

	// 
	info_p=new Tplist_iterator(info);
	if(!info_p){err(ERR_NOMEM);return;}

	//  
	new_selected=(preselected >= (*info_p).get_items())?0:preselected;
	selected_line=new_selected;
	base_line=new_selected;
	p->y=0;
}

// **********************************************************************
//  
u_int	Tvbpaper::get_selected()
{
	return selected_line;
}

// **********************************************************************
//   
// **********************************************************************
void	Tvbpaper::up()
{
Twin_list_item_p	p;

	//?  
	if(!info_p)return;

	//  
	p=(Twin_list_item_p)children[0];
	if(!p){err2(ERR_ZDATA,"child list error");}

	//  
	if(!selected_line)return;
	selected_line--;

	if(!(p->y))base_line--;
	else p->y--;

	// 
	set_page();
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tvbpaper::dn()
{
Twin_list_item_p	p;

	//?  
	if(!info_p)return;

	//  
	p=(Twin_list_item_p)children[0];
	if(!p){err2(ERR_ZDATA,"child list error");}

	//  
	if((selected_line+1)>=(*info_p).get_items())return;
	selected_line++;

	if((p->y+1)>=ly)base_line++;
	else p->y++;

	// 
	set_page();
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tvbpaper::pg_up()
{
Twin_list_item_p	p;

	//?  
	if(!info_p)return;

	//  
	p=(Twin_list_item_p)children[0];
	if(!p){err2(ERR_ZDATA,"child list error");}

	//  
	if(base_line>ly)base_line-=ly;
	else
	 {
	  if(!base_line)
	   {
	    if(!p->y)return;
	    else p->y=0;
	   }
	  base_line=0;
	 }

	selected_line=base_line+p->y;

	// 
	set_page();
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tvbpaper::pg_dn()
{
Twin_list_item_p	p;
u_int			j;

	//?  
	if(!info_p)return;

	//  
	p=(Twin_list_item_p)children[0];
	if(!p){err2(ERR_ZDATA,"child list error");}

	j=(*info_p).get_items();
	//  
	if( (base_line+ly) >= j)
	 {
	  if( (base_line+p->y+1) >= j)return;
          p->y=j-base_line-1;
	 }
	else base_line+=ly;

	if((base_line+p->y) >= j)p->y=j-base_line-1;
	selected_line=base_line+p->y;

	// 
	set_page();
	refresh(last_x,last_y);
}

// **********************************************************************
