#include "vm_app.h"
#include "view\status.h"

// **********************************************************************
//  
// **********************************************************************
//  : percent
class	Tsi_percent;
typedef Tsi_percent *Tsi_percent_p;

//  : texthex
class	Tsi_texthex;
typedef Tsi_texthex *Tsi_texthex_p;

//  : wrapunwrap
class	Tsi_wrapunwrap;
typedef Tsi_wrapunwrap *Tsi_wrapunwrap_p;

//  : fname
class	Tsi_fname;
typedef Tsi_fname *Tsi_fname_p;

// **********************************************************************
//  : percent
class	Tsi_percent:public Tstatus_item
{
public:
	inline Tsi_percent(Tview& view):Tstatus_item(view){}

	//
	Tstring& get_str()
	 {
	  if(!view.filter_p)~str;
	  else
	   {
	    char 	s[80];
	    u_int	p;

	    p=view.filter_p->get_percent();
	    if(p>100)sprintf(s,"???%");
	    else sprintf(s,"%03u%",p);
	    str=s;
	   }
	  return str;
	 }
};

// **********************************************************************
//  : texthex
class	Tsi_texthex:public Tstatus_item
{
public:
	inline Tsi_texthex(Tview& view):Tstatus_item(view){}

	//
	Tstring& get_str()
	 {
	  if(!view.filter_p)~str;
	  else
	   {
	    u_int	m=view.filter_p->get_submode_number();

	    if(m==LNMETA_MODE_HEX)str="hex";
	    else if(m==LNMETA_MODE_TEXT)str="text";
	     else str="? mode";
	   }
	  return str;
	 }
};

// **********************************************************************
//  : wrapunwrap
class	Tsi_wrapunwrap:public Tstatus_item
{
public:
	inline Tsi_wrapunwrap(Tview& view):Tstatus_item(view){}

	//
	Tstring& get_str()
	 {
	  Tlnmeta_mode_p	p;

	  if(
	     (!view.filter_p)
	     ||(view.filter_p->get_submode_number()!=LNMETA_MODE_TEXT)
	    )
	   ~str;
	  else
	   {
	    p=view.filter_p->get_submode();
	    if(!p)~str;
	    else
	     {
	      u_int	m=p->get_submode_number();

	      if(m==LNMETA_MODE_UNWRAP)str="unwrap";
	      else if(m==LNMETA_MODE_WRAP)str="wrap";
		else if(m==LNMETA_MODE_WORDWRAP)str="wordwrap";
		 else str="? text mode";
	     }
	   }
	  return str;
	 }
};

// **********************************************************************
//  : fname
class	Tsi_fname:public Tstatus_item
{
public:
	inline Tsi_fname(Tview& view):Tstatus_item(view)
	 {
	  en_trunc=1;
	  en_points=1;
	  right_points=0;
	 }

	//
	Tstring& get_str()
	 {
	  Tfile_p	p;

	  if(!view.filter_p)~str;
	  else
	   {
	    p=Tfile_p(&(view.filter_p->get_stream() ));

	    str=p->file_name;
	    //    
	    p->fs_unicode.convert(-str);
	   }
	  return str;
	 }
};

// **********************************************************************
// 
// **********************************************************************
//  
	Tstatus::Tstatus(Tview& aview):view(aview)
{
Tsi_percent_p		ps_p;
Tsi_texthex_p		th_p;
Tsi_wrapunwrap_p 	wu_p;
Tsi_fname_p		fn_p;

	//   
	ps_p=new Tsi_percent(aview);
	th_p=new Tsi_texthex(aview);
	wu_p=new Tsi_wrapunwrap(aview);
	fn_p=new Tsi_fname(aview);
	if(
	   (!ps_p)
	   ||(!th_p)
	   ||(!wu_p)
	   ||(!fn_p)
	  ){err(ERR_NOMEM);return;}

	// 
	llist+=(Tlist_item_p)fn_p;

	// 
	rlist-=(Tlist_item_p)wu_p;
	rlist-=(Tlist_item_p)th_p;
	rlist-=(Tlist_item_p)ps_p;
}

// **********************************************************************
	Tstatus::~Tstatus()
{
u_int		i,j;
Tlist_item_p	p;

	// 
	j=llist.get_items();
	llist[0];
	for(i=0;i<j;i++)
	 {
	  p=-llist;
	  delete p;
	  llist++;
	 }
	llist.zap();

	// 
	j=rlist.get_items();
	rlist[0];
	for(i=0;i<j;i++)
	 {
	  p=-rlist;
	  delete p;
	  rlist++;
	 }
	rlist.zap();
}

// **********************************************************************
//     
Tstring& Tstatus::get_str()
{
u_int		lx=view.lx;
Tstring		s(0,lx);
char_p		p=-s;

u_int		i,j,nlx;

	// 
	memset(p,' ',lx);
	*(p+lx)=0;
	nlx=lx;

	//*************
	// 
	j=rlist.get_items();
	rlist[0];
	for(i=0;i<j;i++)
	 {
	  Tstatus_item_p	t;
	  u_int			len;

	  t=Tstatus_item_p(-rlist);

	  //?  
	  if(
	     (t)
	     &&( ( len=t->get_str().len() )!=0 )
	    )
	   {
	    //? 
	    if(nlx > len+3)
	     {
	      //
	      nlx-=len+3;
	      memcpy(p+nlx," | ",3);

	      //
	      memcpy(p+nlx+3,-(t->get_str()),len);
	     }
	   }

	  rlist++;
	 }

	//*************
	// 
	j=llist.get_items();
	llist[0];
	for(i=0;i<j;i++)
	 {
	  Tstatus_item_p	t;
	  u_int			len;

	  t=Tstatus_item_p(-llist);

	  //?  
	  if(
	     (t)
	     &&( ( len=t->get_str().len() )!=0 )
	    )
	   {
	    //? 
	    if(nlx > len)
	     {
	      //
	      memcpy(p,-(t->get_str()),len);
	      p+=len;
	      nlx-=len;
	     }

	    //
	    if(
	       (j>1)
	       &&(nlx>3)
	      )
	     {
	      nlx-=3;
	      memcpy(p," | ",3);
	      p+=3;
	     }

	   }

	  llist++;
	 }

        //    c
	str=s;
	return str;
}

// **********************************************************************

