#include "vm_app.h"
#include <classes\tstrfile.h>
#include <winitems\lbpaper.h>

//for help info
//#include <classes\tstrfile.h>
//#include <classes\lnfemu.h>

#include "view\status.h"

// **********************************************************************
//   view
// **********************************************************************
// 
class	Tview_paper;
typedef Tview_paper *Tview_paper_p;

// **********************************************************************
// 
class	Tview_paper:public Tlbpaper
{
public:
	inline Tview_paper(Tview& aview):
		view(aview)
		,st_line(aview)
	{}

private:
	//  
	Tview&	view;

	// 
	Tstatus st_line;

//   
public:
	//rerdraw win from positions on desktop
	void	refresh();
};

// **********************************************************************
static u_int	ref_times=0;
//rerdraw win from positions on desktop
void	Tview_paper::refresh()
{
Twin_p		w;

	// 
	Tlbpaper::refresh();

	++ref_times;
	if(!view.en_status)return;

	{
	 char 		s[80];
	 char_p		p;//=0;

	 p=-(st_line.get_str());
	 if(!p)
	  {
	   sprintf(s,"Tview_paper::refreshed %u times",ref_times);
	   p=s;
	  }
	 view.set_caption(p,1);
	}

	// 
	w=view.get_caption();
	w->refresh();
}

// **********************************************************************
//
// **********************************************************************
//  
	Tview::Tview()
{
Tview_paper_p	p;

	//  
	p=new Tview_paper(*this);
	if(!p){err(ERR_NOMEM);return;}

	p->color=GREEN;
	p->bkcolor=BLACK;

	// paper & skip call set_size(?,?)
	set_paper(p,1);

	//  status
	en_status=1;
	set_caption("load config...",1);

	//input stream
	filter_p=NULL;

	// desktop
	cur_resolution=C80;
	set_resolution(cur_resolution);
}

// **********************************************************************
	Tview::~Tview()
{
	//warn("Tview::~Tview()");
	desktop_p->resolution(C80);

	//   ,   
	hide_children=1;
	hide_self=0;

	color=LIGHTGRAY;
	bkcolor=BLACK;
	clear(0,0);
}

// **********************************************************************
// 
void	Tview::view( Tvmmeta& filter )
{
Tview_paper_p	p;

//  
//char		load_started=1;

	// 
	p=Tview_paper_p(get_paper());
	if(!p){err2(ERR_BADPAR,"bad child in list");return;}

//	warn("here");
//	::exit(0);
	//    
	filter_p=&filter;
	p->set_filter(filter);

	// 
	refresh(last_x,last_y);

	//  
	//p->home();
        p->sync_by_stream();

	// 
	sw_active();

	//main cycle
	exit_pressed=0;

	while(!exit_pressed)
	 {
	  desktop_p->keyb_p->action(KEYB_ACTION_NOWAIT);
/*
	  //      
	  if(load_started)
	   {
	    // 
	    filter.partitional_count();

	    // 
	    ( Tstatus_p(&(p->win)) )->refresh(p->x,p->y);

	    //? 
	    if(!filter.is_loading)load_started=0;
	   }
	  //?  
	  else
	   if(filter.is_loading)load_started=1;
*/
	 }

	// 
	sw_active();
}

// **********************************************************************
//  Tview
// **********************************************************************
void	Tview::exit()
{
	exit_pressed=1;
}


// **********************************************************************
void	Tview::help()
{
//  
#define VIEW_HLP "\
\t--------------------\n\
\t \n\
\t--------------------\n\
           ESC  Enter\n\
      \n\
\n\
\t-------------------------------------\n\
\t   \n\
\t-------------------------------------\n\
                          Ctrl+Page_UP\n\
                      Ctrl+Page_DN\n\
                    Page_UP\n\
                     Page_DN\n\
                      _\n\
                       _\n\
 10            Ctrl+_\n\
 10             Ctrl+_\n\
\t  \n\
             Home\n\
            Ctrl+Home\n\
           Ctrl+End\n\
                            _\n\
                           _\n\
          Ctrl+_\n\
         Ctrl+_\n\
\t\n\
                            F7\n\
                       Ctrl+L  Shift+F7\n\
\n\
\t---------------------\n\
\t \n\
\t---------------------\n\
\t\n\
Unwrap/Wrap/Word wrap            F2\n\
/hex                        F4\n\
 -         F9\n\
\t\n\
                 Alt+F9\n\
                   F8\n\
                  Alt+F8\n\
\n\
                 ESC  Alt+X\
"
static Tstring		view_help_info(VIEW_HLP);
TstringAsTfile		strfile(&view_help_info);
//Tfile			strfile("testx.txt");

//   help
Tlnmeta_mode_unwrap	filter(strfile);
//Tlnmeta		filter(strfile);

//   help
Tlbrouser_dlg	win;
//    help
u_int		w_lx,w_ly;

//     help
Tcwin_p	     	w;
Tlbpaper_p	p=0;

//o
char		caption[]=":  ";
char		s[160];

	//     help
	w=Tcwin_p(win.get_paper());
	if(w)p=Tlbpaper_p(w->get_paper());
	if(!p){err2(ERR_BADPAR,"bad child in list");return;}
	//  
	p->en_sw_wrap=0;
	p->en_sw_hex=0;

	// 
	sprintf(s,"%s",caption);
	::msg_unicode.convert(s);
	// 
	win.set_caption(s);

	//    help
	w_lx=double(desktop_p->lx)/3*2;
	w_ly=double(desktop_p->ly)/3*2;

	//  
	win.set_size(w_lx,w_ly);
	//   
	win.set_filter(filter);
	//     
	filter.get_stream().unicode.source(::msg_unicode.get_unicode_type(1));

	//
	win.execute(DLG_CLEAR_KEYS);

	//   
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tview::sw_status()
{
	en_status=char( (en_status)? 0: 1);

	if(en_status)set_caption("initializing status line...",1);
	else set_caption(0,1);

	set_size(lx,ly);
	refresh(last_x,last_y);
}

// **********************************************************************
void	Tview::sw_resolution()
{
	if(cur_resolution==C80)cur_resolution=C4350;
	else cur_resolution=C80;

	set_resolution(cur_resolution);

	refresh(last_x,last_y);
}

// **********************************************************************
//  
void	Tview::select_code_dlg(char src)
{
//o
char		caption_d[]=" ";
char		caption_s[]=" ";
//   
Tvbrouser_dlg	w;
//    
u_int		w_lx,w_ly;

u_int		i;
char		s[160];

	// 
	sprintf(s,"%s: %s",src?caption_s:caption_d,
		 filter_p->get_stream().unicode.type_name(
		  filter_p->get_stream().unicode.get_unicode_type(src))
	       );
	::msg_unicode.convert(s);
	// 
	w.set_caption(s);

	//     
	w_lx=select_code_lx;
	if( (strlen(s)+5) > w_lx )w_lx=(strlen(s)+5);
	if(w_lx>lx)w_lx=lx;
	w_ly=(ly < (UNICODE_TYPES+1))?ly:UNICODE_TYPES+1;

	//  
	w.set_list_for_select(select_code_vl);
	//  
	w.set_size(w_lx,w_ly);

	//
	i=w.execute(DLG_CLEAR_KEYS);

	//? 
	if(w.get_exit_status()==DLG_OK)
	 {
	  if(src)
	   filter_p->get_stream().unicode.source( t_unicode_type(i) );
	  else
	   filter_p->get_stream().unicode.target( t_unicode_type(i) );
	 }

	//   
	refresh(last_x,last_y);
}

// **********************************************************************
//   
void	Tview::select_src_code()
{
	select_code_dlg(1);
}

// **********************************************************************
//   
void	Tview::select_dst_code()
{
	select_code_dlg(0);
}

// **********************************************************************


